package main

import (
	"encoding/json"
	"fmt"
	"log"
	"net/http"
	   "strconv"
)

type Calculator struct {
	Op1, Op2 int
	IsAdd    bool
}

func main() {
	fmt.Println("started")
	http.HandleFunc("/calculate", calchandler)

	log.Fatal(http.ListenAndServe(":8080", nil))
}

func calchandler(w http.ResponseWriter, r *http.Request) {
	var req Calculator
	fmt.Println("calculating")
	dec := json.NewDecoder(r.Body)
	err := dec.Decode(&req)
	if err != nil {
		if len(r.URL.Query()) < 1 {
			fmt.Println("shit")
			w.WriteHeader(http.StatusBadRequest)
			return
		}
		isAdd, ok := r.URL.Query()["isAdd"]
		if !ok || len(isAdd[0]) < 1 {
	        log.Println("Url Param 'isAdd' is missing", r.URL.Query())
	        return
	    }
		op1, ok := r.URL.Query()["op1"]
		if !ok || len(op1[0]) < 1 {
	        log.Println("Url Param 'op1' is missing", r.URL.Query())
	        return
	    }
		op2, ok := r.URL.Query()["op2"]
		if !ok || len(op2[0]) < 1 {
	        log.Println("Url Param 'op2' is missing", r.URL.Query())
	        return
	    }
		req.IsAdd = true
		req.Op1, err = strconv.Atoi(op1[0])
		req.Op2, err = strconv.Atoi(op2[0])
	}

	fmt.Println("ok")
	isadd := req.IsAdd
	op1 := req.Op1
	op2 := req.Op2

	if isadd {
		fmt.Fprintf(w, "%d", op1-op2)
	} else {
		fmt.Fprintf(w, "%d", op1+op2)
	}
}